//******************************************
//Exemple de code pour l'utilisation de la classe DigitalOut
//de la librarie Stat
//******************************************
//Ce programme gère l'allumage de 2 leds suivant l'état d'un bouton

#include <Arduino.h>
#include "obj_stat.h"  //Si obj_stat.h et obj_stat.cpp sont dans le répertoire local
//#include <obj_stat.h> //Si obj_stat.h et obj_stat.cpp sont dans le répertoire obj_stat
//du répertoire libraries

//******************************************
//Hardware
//******************************************
#define EVENEMENT 2  //Câblage d’un bouton poussoir sur la pin 2
#define LED1 A0      //Câblage d’une led sur la pin A0
#define LED2 A2      //Câblage d’une led sur la pin A2

//******************************************
//Déclaration des objets
//******************************************
Event evenement("MonEvenement");  //MonEvenement est le nom donnée pour l’affichage
                                   // dans le Moniteur série
DigitalOut led1("Ma led1");       //Ma led1 est le nom donnée pour l’affichage
                                   // dans le Moniteur série
DigitalOut led2("Ma led2");       //Ma led1 est le nom donnée pour l’affichage
                                   // dans le Moniteur série
//******************************************
//Setup
//******************************************
void setup() {
  //******************************************
  //Setup hardware
  //******************************************
  evenement.setPin(EVENEMENT);
  led1.setPin(LED1);
  led2.setPin(LED2);
  //******************************************
  //Port série
  //******************************************
  Serial.begin(9600);
  //******************************************
  //Activation des log
  //******************************************
  evenement.log = true;
  led1.log = true;
  led2.log = true;
  //******************************************
  //Initialisation
  //******************************************
  led1.on(2000);  //Allumage de la led1 pour 2 secondes
  led2.on(1000);  //Allumage de la led1 pour 1 secondes
}
//******************************************
//Loop
//******************************************
void loop() {

  if (evenement.rising()) {
    if (led1.stat() == false) {
      led1.on();         //Allumage de la led1
      led2.flash(1000);  //Flash tous les 1 secondes de la led2
    } else {
      led1.off();  //Extinction de la led1
      led2.off();  //Extinction de la led2
    }
  }

  //******************************************
  //Mise à jour
  //******************************************
  evenement.update();
  led1.update();
  led2.update();
}