//******************************************
//Exemple de code pour l'utilisation de la classe Cevent
//de la librarie Stat
//******************************************
//Ce programme affiche front montant ou front descendant dans le moniteur série en fonction de l'état du bouton

#include <Arduino.h>
#include "obj_stat.h"  //Si obj_stat.h et obj_stat.cpp sont dans le répertoire local
//#include <obj_stat.h> //Si obj_stat.h et obj_stat.cpp sont dans le répertoire obj_stat
//du répertoire libraries

//******************************************
//Hardware
//******************************************
#define EVENEMENT 2  //Câblage d’un bouton poussoir sur la pin 2

//******************************************
//Déclaration des objets
//******************************************
Event evenement("MonEvenement");  //MonEvenement est le nom donnée pour l’affichage
                                   // dans le Moniteur série
//******************************************
//Setup
//******************************************
void setup() {
  //******************************************
  //Setup hardware
  //******************************************
  evenement.setPin(EVENEMENT);
  //******************************************
  //Port série
  //******************************************
  Serial.begin(9600);
  //******************************************
  //Activation des log
  //******************************************
  evenement.log = true;
}
//******************************************
//Loop
//******************************************
void loop() {

  if (evenement.rising()) {
    Serial.println("Front Montant");
  }
  if (evenement.falling()) {
    Serial.println("Front Descendant");
  }
  //******************************************
  //Mise à jour
  //******************************************
  evenement.update();
}