#include "obj_stat.h"  //Inclusion de la bibliothèque placée dans le répertoire de travail

//Déclarations
static Event fin1("fin1");                          //variable associée à l'entrée fin1
static Event fin2("fin2");                          //variable associée à l'entrée fin2
static Stat Systeme_actif("Système Actif", 1);      //variable de type Stat associée à l'état Système Actif
static Stat Systeme_inactif("Système Inactif", 2);  //variable de type Stat associée à l'état Système Inactif
static Stat Etat1("Etat1", 10);                     //variable de type Stat associée au sous état Etat1 de l'état Système Actif (Région 1)
static Stat Etat2("Etat2", 11);                     //variable de type Stat associée àu sous état Etat2 de l'état Système Actif (Région 2)
static Stat FinRegion1("Fin Région 1", 12);         //variable de type Stat associée au pseudo-état de fin de la Région 1
static Stat FinRegion2("Fin Région 2", 13);         //variable de type Stat associée au pseudo-état de fin de la Région 2

static Stat* p_etatCourant;       //pointeur associé à l'état courant
static Stat* p_etatCourant_1_R1;  //pointeur associé au sous état courant de l'état 1 Système Actif (Région 1)
static Stat* p_etatCourant_1_R2;  //pointeur associé au sous état courant de l'état 1 Système Actif (Région 2)

//Setup
void setup() {
  Serial.begin(115200);                      //Activation port série pour visualisation
  fin1.setPin(3);                            //La pin 3 est définie comme une entrée (bouton poussoir par exemple)
  fin2.setPin(4);                            //La pin 4 est définie comme une entrée  (bouton poussoir par exemple)
  p_etatCourant = Systeme_actif.activate();  //Etat initial
  //log
  fin1.log = false;
  fin2.log = false;
  Serial.println("**** Fin du setup ****");
}
//Loop
void loop() {
  //Mise à jour des entrées
  fin1.update();
  fin2.update();
  //Gestion de l'évolution des états
  completion(p_etatCourant, Systeme_actif, Systeme_inactif);
  transition(p_etatCourant_1_R1, Etat1, FinRegion1, fin1.rising());
  transition(p_etatCourant_1_R2, Etat2, FinRegion2, fin2.rising());
  //Gestion de l'état composite
  if (Systeme_actif.exit_()) {
    Serial.println("++ Systeme_actif.exit_()++");
    p_etatCourant_1_R1->desactivate();  //Désactivation de l'état actif région 1
    p_etatCourant_1_R2->desactivate();  //Désactivation de l'état actif région 2
  }
  if (Systeme_actif.do_()) {
    if (FinRegion1.stat() && FinRegion2.stat()) {  //Si tous les états finaux sont atteints,
      Serial.println("++ Systeme_actif.do_()->fin ++");
      Systeme_actif.completion_event = true;  //on déclare l'état composite comme terminé
    }
  }
  if (Systeme_actif.entry_()) {
    Serial.println("++ Systeme_actif.entry_() ++");
    p_etatCourant_1_R1 = Etat1.activate();  //Sous état initial région 1
    p_etatCourant_1_R2 = Etat2.activate();  //Sous état initial région 2
  }
  //Gestion automatique de l'évolution du diagramme
  Systeme_actif.update();
  Systeme_inactif.update();
  Etat1.update();
  Etat2.update();
  FinRegion1.update();
  FinRegion2.update();
}