#include "obj_stat.h"  //Inclusion de la bibliothèque placée dans le répertoire de travail

//Déclarations
static Event bp_on("bouton on");    //variable associée au bouton poussoir on
static Event bp_off("bouton off");  //variable associée au bouton poussoir off
static Stat Marche("Marche", 0);    //variable de type CStat associée à l'état Marche
static Stat Arret("Arret", 1);      //variable de type CStat associée à l'état Arret

static Stat* p_etatCourant;  //pointeur associé à l'état courant



//Setup
void setup() {
  //Activation des log et du moniteur série
  bp_on.log = true;
  bp_off.log = true;
  Marche.log = true;
  Arret.log = true;
  Serial.begin(115200);               //Moniteur série
  bp_on.setPin(3);                    //La pin 3 est définie comme une entrée (bouton poussoir)
  bp_off.setPin(4);                   //La pin 4 est définie comme une entrée (bouton poussoir)
  p_etatCourant = Marche.activate();  //Etat initial
}
//Loop
void loop() {
  //Mise à jour des entrées
  bp_on.update();
  bp_off.update();
  //Gestion de l'évolution des états
  transition(p_etatCourant, Marche, Arret, bp_off.rising());
  transition(p_etatCourant, Arret, Marche, bp_on.rising());
  //Gestion automatique de l'évolution du diagramme
  Marche.update();
  Arret.update();
}