#include "obj_stat.h"  //Inclusion de la bibliothèque placée dans le répertoire de travail

//Déclarations
static Event fin1("bouton fin1");               //variable associée au bouton poussoir
static Event bp_test("bouton test");            //variable associée au bouton poussoir
static Stat Systeme_Actif("Systeme_actif", 1);  //variable de type CStat associée à l'état Systeme_Actif
static Stat Fin("psudo-état fin", 2);           //variable de type CStat associée au pseudo-état Fin

static Stat* p_etatCourant;  //pointeur associé à l'état courant

static unsigned int Activite;  //Numéro de l'activité en cours
static bool test;              //Variable boolenne du diagramme d'activité
//Setup
void setup() {
  Systeme_Actif.log = true;                  //Activation des log
  Fin.log = true;                            //Activation des log
  Serial.begin(115200);                      //Moniteur série
  fin1.setPin(3);                            //La pin 3 est définie comme une entrée (bouton poussoir)
  bp_test.setPin(4);                         //La pin 4 est définie comme une entrée (bouton poussoir)
  p_etatCourant = Systeme_Actif.activate();  //Etat initial
  Serial.println("**** Fin du setup ****");
}
//Loop
void loop() {
  //Mise à jour des entrées
  fin1.update();
  bp_test.update();

  //Gestion de l'évolution des états
  completion(p_etatCourant, Systeme_Actif, Fin);

  //Gestion des activités
  if (Systeme_Actif.do_()) {
    switch (Activite) {
      case 0:
        Serial.println("Systeme_Actif : Activité 0 vers 1");
        Activite++;  //On passe à l'étape suivante sans condition (entrée)
        break;
      case 1:  //Activité 1
        //Ecrire ici le code associé à l'étape 1
        //...
        //...
        if (fin1.rising()) {  //On passe à l'étape suivante seulement si on a un front montant de fin1
          Serial.println("Systeme_Actif : Activité 1 vers 2");
          Activite++;
        }
        break;
      case 2:  //Activité 2
        //Ecrire ici le code associé à l'étape 2
        //...
        test = bp_test.stat();  //Pour l'exemple, la variable test est associée à l'état d'un bouton poussoir
        //...
        if (test) {  //Si le test est vérifié
          Serial.println("Systeme_Actif : Activité 2 vers 3");
          Activite++;  //on passe à l'étape suivante
        } else {
          Serial.println("Systeme_Actif : Retour Activité 1");
          Activite = 1;  //Sinon on revient à l'étape 1
        }
        break;
      case 3:  //Activité 3
        //L'étape 3 est l'étape de fin d'activité
        //On peut donc déclarer l'état comme terminé
        Systeme_Actif.completion_event = true;
        break;
    }
  }
  if (Systeme_Actif.entry_()) {
    Activite = 0;  //Initialisation du diagramme d'activité à l'étape 0 (entrée)
  }
  //Gestion automatique de l'évolution du diagramme
  Systeme_Actif.update();
  Fin.update();
}