#include "obj_stat.h"     //Inclusion de la bibliothèque placée dans le répertoire de travail

//Déclarations
static bool bp_on ;               //variable associée au bouton poussoire on
static bool bp_off ;              //variable associée au bouton poussoire off
static Stat Marche("Marche",0) ; //variable de type Stat associée à l'état Marche
static Stat Arret("Arret",1) ;   //variable de type Stat associée à l'état ArretArret

static Stat * p_etatCourant ;  //pointeur associé à l'état courant

//Setup
void setup() {
  Serial.begin(115200) ;
  pinMode(3, INPUT );    //La pin 3 est définie comme une entrée (bouton poussoir)
  pinMode(4, INPUT );    //La pin 4 est définie comme une entrée (bouton poussoir)
  p_etatCourant = Marche.activate() ; //Etat initial
  Serial.println("**** Fin du setup ****") ;  
}  
//Loop
void loop() {
  //Mise à jour des entrées
  bp_on = digitalRead(3) ;
  bp_off = digitalRead(4) ;  
  //Gestion de l'évolution des états
  transition(p_etatCourant,Marche,Arret,bp_off);
  transition(p_etatCourant,Arret,Marche,bp_on); 
  //Gestion automatique de l'évolution du diagramme
  Marche.update();
  Arret.update(); 
}
