#include "obj_stat.h"  //Inclusion de la bibliothèque placée dans le répertoire de travail

//Déclarations
static Event bp_on;                                 //variable associée au bouton poussoir on
static Event bp_off;                                //variable associée au bouton poussoir off
static Event bp_fin;                                //variable associée au bouton poussoir fin
static Stat Systeme_actif("Système Actif", 1);      //variable de type Stat associée à l'état Système Actif
static Stat Systeme_inactif("Système Inactif", 2);  //variable de type Stat associée à l'état Système Inactif
static Stat Marche("Marche", 10);                   //variable de type Stat associée au sous état Marche de l'état Système Actif
static Stat Arret("Arret", 11);                     //variable de type Stat associée àu sous état Arret de l'état Système Actif

static Stat* p_etatCourant;    //pointeur associé à l'état courant
static Stat* p_etatCourant_1;  //pointeur associé au sous état courant de l'état 1 Système Actif

//Setup
void setup() {
  Serial.begin(115200);                      //Activation port série pour visualisation
  bp_on.setPin(3);                           //La pin 3 est définie comme une entrée (bouton poussoir)
  bp_off.setPin(4);                          //La pin 4 est définie comme une entrée (bouton poussoir)
  bp_fin.setPin(5);                          //La pin 5 est définie comme une entrée (bouton poussoir)
  p_etatCourant = Systeme_actif.activate();  //Etat initial
  Serial.println("**** Fin du setup ****");
}
//Loop
void loop() {
  //Mise à jour des entrées
  bp_on.update();
  bp_off.update();
  bp_fin.update();
  //Gestion de l'évolution des états
  transition(p_etatCourant, Systeme_actif, Systeme_inactif, bp_fin.rising());
  transition(p_etatCourant_1, Marche, Arret, bp_off.rising());
  transition(p_etatCourant_1, Arret, Marche, bp_on.rising());
  //Gestion de l'état composite
  if (Systeme_actif.exit_()) {
    p_etatCourant_1->desactivate();  //Désactivation de l'état actif
  }
  if (Systeme_actif.entry_()) {
    p_etatCourant_1 = Marche.activate();  //Sous état initial
  }
  //Gestion automatique de l'évolution du diagramme
  Systeme_actif.update();
  Systeme_inactif.update();
  Marche.update();
  Arret.update();
}